(function($, Drupal) {

  "use strict";

  Drupal.behaviors.graphapi = {
    attach: function(context, settings) {
      $('.graph-phyz-node').draggable({
        start: function(event, ui) {
          var $this = jQuery(this);
          var $container = $this.parents('.graph-phyz').first();
          var opts = $container.data('options');
          opts.dragging = true;
          $container.data('options', opts);
        },
        stop: function(event, ui) {
          var $this = $(this);
          var $container = $this.parents('.graph-phyz').first();
          var opts = $container.data('options');
          opts.dragging = false;
          $container.data('options', opts);
        }
      });

      $('.graph-phyz-nodes').droppable({
        drop: function(event, ui) {
          var draggable = ui.draggable;
          var position = draggable.position();
          var physics = draggable.data('physics');
          var $container = draggable.parents('.graph-phyz').first();
          $.graphapi.physics.init(draggable, position.left + physics.dx, position.top + physics.dy);
          $.graphapi.draw($container);
        }
      });

      $('.graph-phyz-node').click(function(eventData) {
        var $this = $(this);
        // TODO: This needs better positioning:
        // These are not ok: [eventData.clientX, eventData.clientY]
        $('.graph-phyz-content', $this).dialog();
      });

    }
  };

})(jQuery, Drupal);
